<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
require_once(CLASSPATH."ps_database.php");

class tmgco_language
{
    var $PHPSHOP_ADMIN_CFG_TMGCO_DEBUG                       = "Отладочный режим";
    var $PHPSHOP_ADMIN_CFG_TMGCO_DEBUG_EXPLAIN               = "Отладочный режим. Когда включен счет не выписывается.";

    var $PHPSHOP_ADMIN_CFG_TMGCO_PAYMENT_FORM_URL            = "URL для генерации формы оплаты";
    var $PHPSHOP_ADMIN_CFG_TMGCO_PAYMENT_FORM_URL_EXPLAIN    = "*URL для получения сгенерированной формы оплаты и её отображение на сайте";
    var $PHPSHOP_ADMIN_CFG_TMGCO_TMGCO_SECRET_KEY            = "Секретное слово";
    var $PHPSHOP_ADMIN_CFG_TMGCO_TMGCO_SECRET_KEY_EXPLAIN    = "";

    var $PHPSHOP_ADMIN_CFG_TMGCO_URL_SUCCESS		= "URL for Success";
    var $PHPSHOP_ADMIN_CFG_TMGCO_URL_FAILURE            = "URL for Error";
    var $PHPSHOP_ADMIN_CFG_TMGCO_URL_NOTIFY             = "URL for Postback/Notify";


    var $PHPSHOP_TMGCO_ORDER_STATUS_PENDING_SET              = "Пользователь сделал заказ, но ещё не оплатил. Заказу присвоен статус &laquo;в процессе оплаты&raquo;.";
    var $PHPSHOP_ADMIN_CFG_TMGCO_PENDING_STATUS              = "Статус готов к оплате";
    var $PHPSHOP_ADMIN_CFG_TMGCO_PENDING_STATUS_EXPLAIN      = "Статус, при котором заказ <i>разрешено</i> оплатить.";
    
    var $PHPSHOP_TMGCO_ORDER_STATUS_SUCCESS_SET              = "Пользователь успешно оплатил счёт способом оплаты %s. Заказу присвоен статус &laquo;успешной оплаты&raquo;.";
    var $PHPSHOP_ADMIN_CFG_TMGCO_STATUS_SUCCESS              = "Статус успешной оплаты";
    var $PHPSHOP_ADMIN_CFG_TMGCO_STATUS_SUCCESS_EXPLAIN      = "Выбранный статус будет выставлен заказу, который был успешно оплачен.";
    
    var $PHPSHOP_TMGCO_ERROR_WRONG_ORDER_NUMBER              = "Неправильный номер заказа";
    var $PHPSHOP_TMGCO_ERROR_UNDEFINED_CURRENCY              = "Неизвестная валюта";
    
    var $PHPSHOP_TMGCO_PAYMENT_METHOD                        = "Метод оплаты";
    var $PHPSHOP_TMGCO_PAYMENT_CURRENCY                      = "валюта";
    var $PHPSHOP_TMGCO_PAYMENT_TOTAL                         = "Итого с комиссией";
    var $PHPSHOP_TMGCO_PAYMENT_COMMISSION                    = "Комиссия";
    var $PHPSHOP_TMGCO_PAY                                   = "Оплатить";
}

class ps_tmgco
{
    var $classname    = "ps_tmgco";
    var $payment_code = "TMGCO";

    private $fiscal_cart = array(); //fz54 cart
    private $order_total = 0; //order total sum
    private $shipping_price = 0; //shipping price
    private $use_taxes = false;
    private $use_delivery = false;
    private $order_params = NULL;
    private $discounts = array();

    /**
     * Conctructor, that merge our language varibles to VM_LANG
     */
    function ps_tmgco()
    {
        global $VM_LANG;
        $status = $VM_LANG->merge('tmgco_language');
    }

    /**
     * Отображение параметров конфигурации этого модуля оплаты
     * @returns boolean False when the Payment method has no configration
     */
    function show_configuration()
    {
        global $db, $VM_LANG;
        if (htmlspecialchars($db->sf("payment_extrainfo")) == '') {
            $db->record[$db->row]->payment_extrainfo = '
<?php
require_once(CLASSPATH."payment/ps_tmgco.php");
$tmgco = new ps_tmgco();
$tmgco->getPaymentForm();
?>
            ';
        }

        /** Загрузка файла конфигурации ***/
        if ($this->has_configuration())
            include_once(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
        else
            return false;
        ?>
    <table style="text-align:left">

        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_PAYMENT_FORM_URL; ?>:</strong></td>
            <td>
                <input type="text" name="TMGCO_PAYMENT_FORM_URL" class="inputbox" style="width:450px" 
                       value="<? if (TMGCO_PAYMENT_FORM_URL != '') echo TMGCO_PAYMENT_FORM_URL; ?>"/>
            </td>
            <td><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_PAYMENT_FORM_URL_EXPLAIN; ?></td>
        </tr>
        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_TMGCO_SECRET_KEY; ?>:</strong></td>
            <td>
                <input type="text" name="TMGCO_SECRET_KEY" class="inputbox" style="width:450px" 
                       value="<? if (TMGCO_SECRET_KEY != '') echo TMGCO_SECRET_KEY; ?>"/>
            </td>
            <td>
                <?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_TMGCO_SECRET_KEY_EXPLAIN; ?></td>
        </tr>


        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_URL_SUCCESS; ?>:</strong></td>
            <td>
                <input type="text" name="TMGCO_URL_SUCCESS" class="inputbox" style="width:450px" 
                       value="<? if (TMGCO_URL_SUCCESS != '') echo TMGCO_URL_SUCCESS; else echo SECUREURL.'index.php?option=com_virtuemart&page=checkout.tmgco_success'; ?>"/>
            </td>
            <td></td>
        </tr>

        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_URL_FAILURE; ?>:</strong></td>
            <td>
                <input type="text" name="TMGCO_URL_FAILURE" class="inputbox" style="width:450px" 
                       value="<? if (TMGCO_URL_FAILURE != '') echo TMGCO_URL_FAILURE; else echo SECUREURL.'index.php?option=com_virtuemart&page=checkout.tmgco_failure' ?>"/>
            </td>
            <td></td>
        </tr>

        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_URL_NOTIFY; ?>:</strong></td>
            <td>
                <input type="text" name="TMGCO_URL_NOTIFY" class="inputbox" style="width:450px" 
                       value="<? if (TMGCO_URL_NOTIFY != '') echo TMGCO_URL_NOTIFY; else echo SECUREURL.'administrator/components/com_virtuemart/tmgco_notify.php'; ?>"/>
            </td>
            <td></td>
        </tr>



        <?php
        $q = "SELECT order_status_name, order_status_code FROM #__{vm}_order_status ORDER BY list_order";
        $dbs = new ps_DB;
        $dbs->query($q);
        $order_status_code = Array();
        $order_status_name = Array();

        while ($dbs->next_record()) {
            $order_status_code[] = $dbs->f("order_status_code");
            $order_status_name[] = $dbs->f("order_status_name");
        }
        ?>


        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_PENDING_STATUS; ?></strong></td>
            <td>
                <select name="TMGCO_PENDING_STATUS" class="inputbox">
                    <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                        if (TMGCO_PENDING_STATUS == $order_status_code[$i]) $selected = 'selected="selected"';
                        else $selected = '';

                        echo '<option ' . $selected . ' value="' . $order_status_code[$i] . '">' . $order_status_name[$i] . '</option>';
                    }
                    ?>
                </select>
            </td>
            <td><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_PENDING_STATUS_EXPLAIN; ?></td>
        </tr>
        <tr>
            <td><strong><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_STATUS_SUCCESS; ?></strong></td>
            <td>
                <select name="TMGCO_VERIFIED_STATUS" class="inputbox">
                    <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                        if (TMGCO_VERIFIED_STATUS == $order_status_code[$i])
                            $selected = 'selected="selected"';
                        else $selected = '';

                        echo '<option ' . $selected . ' value="' . $order_status_code[$i] . '">' . $order_status_name[$i] . '</option>';
                    }
                    ?>
                </select>
            </td>
            <td><?php echo $VM_LANG->PHPSHOP_ADMIN_CFG_TMGCO_STATUS_SUCCESS_EXPLAIN; ?>
            </td>
        </tr>

    </table>
    <?php
    }

    /**
     * Returns the "has_configuration" status of the module
     * @param void
     * @returns boolean True when the configuration is, false when not
     */
    function has_configuration()
    {
        if (file_exists(CLASSPATH . "payment/" . $this->classname . ".cfg.php")) {
            include_once(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
        }
        else {
            if (!$this->write_configuration($d)) {
                return false;
            }
        }
        return true;
    }

    /**
     * Returns the "is_writeable" status of the configuration file
     * @param void
     * @returns boolean True when the configuration file is writeable, false when not
     */
    function configfile_writeable()
    {
        return is_writeable(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
    }

    /**
     * Returns the "is_readable" status of the configuration file
     * @param void
     * @returns boolean True when the configuration file is readable, false when not
     */
    function configfile_readable()
    {
        return is_readable(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
    }

    /**
     * Writes the configuration file for this payment method
     * @param array An array of objects
     * @returns boolean True when writing was successful
     */
    function write_configuration(&$d)
    {
        global $database, $mosConfig_live_site, $mosConfig_absolute_path, $mosConfig_lang, $mosConfig_locale;
                if (is_array($d)) {

                if (!$d['TMGCO_PAYMENT_FORM_URL']) {
                $my_config_array['TMGCO_PAYMENT_FORM_URL']                 = '';
                }
                else $my_config_array['TMGCO_PAYMENT_FORM_URL']            = $d['TMGCO_PAYMENT_FORM_URL'];

                if (!$d['TMGCO_URL_SUCCESS']) {
                $my_config_array['TMGCO_URL_SUCCESS']                 = '';
                }
                else $my_config_array['TMGCO_URL_SUCCESS']            = $d['TMGCO_URL_SUCCESS'];

                if (!$d['TMGCO_URL_FAILURE']) {
                $my_config_array['TMGCO_URL_FAILURE']                 = '';
                }
                else $my_config_array['TMGCO_URL_FAILURE']            = $d['TMGCO_URL_FAILURE'];

                if (!$d['TMGCO_URL_NOTIFY']) {
                $my_config_array['TMGCO_URL_NOTIFY']                 = '';
                }
                else $my_config_array['TMGCO_URL_NOTIFY']            = $d['TMGCO_URL_NOTIFY'];



                
                if (!$d['TMGCO_SECRET_KEY']) {
                $my_config_array['TMGCO_SECRET_KEY']            = '';
                }
                else $my_config_array['TMGCO_SECRET_KEY']       = $d['TMGCO_SECRET_KEY'];
                
                if ($d['TMGCO_PENDING_STATUS'])
                $my_config_array ['TMGCO_PENDING_STATUS']       = $d['TMGCO_PENDING_STATUS'];
                else $my_config_array ['TMGCO_PENDING_STATUS']  = 'P';
                
                if ($d['TMGCO_VERIFIED_STATUS'])
                $my_config_array ['TMGCO_VERIFIED_STATUS']      = $d['TMGCO_VERIFIED_STATUS'];
                else $my_config_array ['TMGCO_VERIFIED_STATUS'] = 'R';
        }

        $config = "<?php if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die('Direct Access to this location is not allowed.');\n\n";

        while (list($key, $value) = each($my_config_array)) {
            if (substr($key, 0, 5) == 'text_') {
                $config .= $value . "\n";
            }
            else {
                $key = strtoupper($key);
                $config .= "define ('" . $key . "', '" . $value . "');\n";
            }
        }
        $config .= "?>";

        if ($fp = fopen(CLASSPATH . "payment/" . $this->classname . ".cfg.php", "w")) {
            fputs($fp, stripslashes($config));
            fclose($fp);

            return true;
        }
        else return false;
    }



// ==================================================================
//
//Форма для оплаты заказа
//Выводится после оформления заказа. Через payment_extrainfo
//
// ------------------------------------------------------------------
    function get_tmgco_url()
    {
        if (file_exists(CLASSPATH . "payment/" . $this->classname . ".cfg.php")) {
            include_once(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
        }
        $url       = TMGCO_PAYMENT_FORM_URL;
        return $url;
    }

    function process_payment($order_number, $order_total, &$d) {
        return true;
    }

    function getPaymentForm() {

        global $db;
        $orderid = $db->f("order_id");
        $order = $this->dbGet("orders", "order_id", $orderid);
        $customer = $this->dbGet("user_info", "user_id", $order->f("user_id"));

        //set order parameters
        $this->setOrderParams($order->f("order_total"),         //sum
                              $customer->f("first_name")
                              . " " .
                              $customer->f("last_name"),        //clientid
                              $orderid,                         //orderid
                              $customer->f("user_email"),       //client_email
                              $customer->f("phone_1"),          //client_phone
                              "",                               //service_name
                              TMGCO_PAYMENT_FORM_URL,           //payment form url
                              TMGCO_SECRET_KEY                  //secret key
        );

        //GENERATE FZ54 CART
        $product_cart_sum = 0;

        $cart_data = $this->dbGet("order_item", "order_id", $this->getOrderParams("orderid"));
        $do_last_record = FALSE;

        do {
            if ($cart_data->is_last_record())
                $do_last_record = TRUE;
            $item_product_obj = NULL;
            $tax_rate_id = NULL;
            $tax_rate_obj = NULL;
            $taxes = array("tax" => "none", "tax_sum" => 0);

            $name = $cart_data->f("order_item_name");
            $qty = $cart_data->f("product_quantity");
            $price = $cart_data->f("product_final_price");
            $sum = number_format($price*$qty, 2, ".", "");
            $product_cart_sum += $sum;

            $item_product_obj = $this->dbGet("product", "product_id", $cart_data->f("product_id"));
            $tax_rate_obj = $this->dbGet("tax_rate", "tax_rate_id", $item_product_obj->f("product_tax_id"));
            $tax_rate = $tax_rate_obj->f("tax_rate")*100;

            if ($tax_rate != NULL) {
                $taxes = $this->setTaxes($sum, $tax_rate);
            }
            $this->updateFiscalCart($this->getPaymentFormType(), 
                                    $name, $price, $qty, $sum, $taxes["tax"], $taxes["tax_sum"]);

            $cart_data->next_record(); //fetch next item
        } while (!$do_last_record);

        //add shipping parameters to cart
        $shipping_tax_rate = 0;
        $shipping_taxes = array("tax" => "none", "tax_sum" => 0);

        $this->setShippingPrice($order->f("order_shipping") + $order->f("order_shipping_tax"));
        $shipping_tax_rate = (int) ($order->f("order_shipping_tax")*118/$this->getShippingPrice());
        $shipping_taxes = $this->setTaxes($this->getShippingPrice(), $shipping_tax_rate);
        $shipping_name = explode("|", $order->f("ship_method_id"));
        $shipping_name = (string) $shipping_name[2];
        if ($this->getShippingPrice() > 0) {
            $this->setUseDelivery(); //for precision correct check
            $this->updateFiscalCart($this->getPaymentFormType(),
                                    $shipping_name,
                                    $this->getShippingPrice(), 1, 
                                    $this->getShippingPrice(), 
                                    $shipping_taxes["tax"],
                                    $shipping_taxes["tax_sum"]);
        }


        //set discounts
        $this->setDiscounts($product_cart_sum);

        //handle possible precision problem
        $this->correctPrecision($product_cart_sum);

        $fiscal_cart_encoded = json_encode($this->getFiscalCart());

        //generate payment form
        $form = "";
        if ($this->getPaymentFormType() == "create") { //create form
            $to_hash = $this->getOrderTotal(TRUE)                .
                       $this->getOrderParams("clientid")     .
                       $this->getOrderParams("orderid")      .
                       $this->getOrderParams("service_name") .
                       $this->getOrderParams("client_email") .
                       $this->getOrderParams("client_phone") .
                       $this->getOrderParams("secret_key");
            $sign = hash ('sha256' , $to_hash);
            $form = '
                <h3>Сейчас Вы будете перенаправлены на страницу банка.</h3> 
                <form name="payment" id="pay_form" action="'.$this->getOrderParams("form_url").'" accept-charset="utf-8" method="post">
                <input type="hidden" name="sum" value = "'.$this->getOrderTotal(TRUE).'"/>
                <input type="hidden" name="orderid" value = "'.$this->getOrderParams("orderid").'"/>
                <input type="hidden" name="clientid" value = "'.$this->getOrderParams("clientid").'"/>
                <input type="hidden" name="client_email" value = "'.$this->getOrderParams("client_email").'"/>
                <input type="hidden" name="client_phone" value = "'.$this->getOrderParams("client_phone").'"/>
                <input type="hidden" name="service_name" value = "'.$this->getOrderParams("service_name").'"/>
                <input type="hidden" name="cart" value = \''.$fiscal_cart_encoded.'\' />
                <input type="hidden" name="sign" value = "'.$sign.'"/>
                <input type="submit" class="btn btn-default" value="Оплатить"/>
                </form>
                <script type="text/javascript">
                window.onload=function(){
                    //setTimeout(fSubmit, 2000);
                }
                function fSubmit() {
                    document.forms["pay_form"].submit();
                }
                </script>';
        }
        else { //order form
            $payment_parameters = array(
                "clientid"=>$this->getOrderParams("clientid"), 
                "orderid"=>$this->getOrderParams('orderid'), 
                "sum"=>$this->getOrderTotal(), 
                "phone"=>$this->getOrderParams("phone"), 
                "client_email"=>$this->getOrderParams("client_email"), 
                "cart"=>$fiscal_cart_encoded);
            $query = http_build_query($payment_parameters);
            $err_num = $err_text = NULL;
            if( function_exists( "curl_init" )) { //using curl
                $CR = curl_init();
                curl_setopt($CR, CURLOPT_URL, $this->getOrderParams("form_url"));
                curl_setopt($CR, CURLOPT_POST, 1);
                curl_setopt($CR, CURLOPT_FAILONERROR, true); 
                curl_setopt($CR, CURLOPT_POSTFIELDS, $query);
                curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 0);
                $result = curl_exec( $CR );
                $error = curl_error( $CR );
                if( !empty( $error )) {
                    $form = "<br/><span class=message>"."INTERNAL ERROR:".$error."</span>";
                    return false;
                }
                else {
                    $form = $result;
                }
                curl_close($CR);
            }
            else { //using file_get_contents
                if (!ini_get('allow_url_fopen')) {
                    $form_html = "<br/><span class=message>"."INTERNAL ERROR: Option allow_url_fopen is not set in php.ini"."</span>";
                }
                else {
                    $form = file_get_contents($server, false, $context);
                }
            }
        }
        if ($form  == "") {
            $form = '<h3>Произошла ошибка при инциализации платежа</h3><p>$err_num: '.htmlspecialchars($err_text).'</p>';
        }

        echo $form;
    }

    function dbGet($table_name, $field_name, $filter) {
        global $db;
        $req  = "SELECT * FROM #__vm_".$table_name." WHERE ".$field_name."=".$filter; 
        $dbst = new ps_DB;
        $dbst->setQuery($req);
        $dbst->query();
        $dbst->next_record();

        return $dbst;
    }

protected function setOrderParams($order_total = 0, $clientid="", $orderid="", $client_email="", 
                                    $client_phone="", $service_name="", $form_url="", $secret_key="")
    {
       $this->setOrderTotal($order_total);
       $this->order_params = array(
           "sum" => $order_total,
           "clientid" => $clientid,
           "orderid" => $orderid,
           "client_email" => $client_email,
           "client_phone" => $client_phone,
           "phone" => $client_phone,
           "service_name" => $service_name,
           "form_url" => $form_url,
           "secret_key" => $secret_key,
       );
    }

    protected function getOrderParams($value)
    {
        return array_key_exists($value, $this->order_params) ? $this->order_params["$value"] : False;
    }

    protected function updateFiscalCart($ftype, $name="", $price=0, $quantity=0, $sum=0, $tax="none", $tax_sum=0)
    {
        //update fz54 cart
        if ($ftype === "create") {
            $name = str_replace("\n ", "", $name);
            $name = str_replace("\r ", "", $name);
            $name = preg_replace('/"{1,}/','\'',$name);
            $name = htmlspecialchars($name);
        }
        $this->fiscal_cart[] = array(
            "name" => $name,
            "price" => $price,
            "quantity" => $quantity,
            "sum" => $sum,
            "tax" => $tax,
            "tax_sum" => number_format($tax_sum, 2, ".", "")
        );
    }

    protected function getFiscalCart()
    {
        return $this->fiscal_cart;
    }

    protected function setDiscounts($cart_sum)
    {
        //set discounts
        if ($cart_sum > ($this->getOrderTotal() - $this->getShippingPrice())) {

            $fiscal_cart_count = count($this->getFiscalCart())-1;
            $discount_modifier_value = ($this->getOrderTotal() - $this->getShippingPrice())/$cart_sum;
            //iterate fiscal cart without shipping
            for ($pos=0; $pos<$fiscal_cart_count; $pos++) {
                $this->fiscal_cart[$pos]["sum"] *= $discount_modifier_value;
                $this->fiscal_cart[$pos]["price"] = $this->fiscal_cart[$pos]["sum"]/$this->fiscal_cart[$pos]["quantity"];
                //formatting
                $this->fiscal_cart[$pos]["price"] = number_format($this->fiscal_cart[$pos]["price"], 3, ".", "");
                $this->fiscal_cart[$pos]["sum"] = number_format($this->fiscal_cart[$pos]["sum"], 2, ".", "");
                //recalculate taxes
                $this->recalculateTaxes($pos);
            }
        }
    }

    protected function correctPrecision($cart_sum)
    {
        //handle possible precision problem
        $fiscal_cart_sum = $cart_sum;
        $total_sum = $this->getOrderTotal(TRUE);
        //add shipping sum to cart sum
        if ($this->getShippingPrice() > 0)
            $fiscal_cart_sum += $this->fiscal_cart[count($this->fiscal_cart)-1]['sum'];
        //debug_info
        //echo "total: " . $total_sum . " - cart: " . $cart_sum;
        $diff_sum = $fiscal_cart_sum - $total_sum;
        if (abs($diff_sum) <= 0.01) {
            $this->setOrderTotal(number_format($total_sum+$diff_sum, 2, ".", ""));
        }
        else {
            if ($this->getUseDelivery() && ($fiscal_cart_sum < $total_sum)) {
                $this->setOrderTotal(number_format($total_sum+$diff_sum, 2, ".", ""));
                $delivery_pos = count($this->getFiscalCart())-1;
                $this->fiscal_cart[$delivery_pos]["price"] = number_format(
                                   $this->fiscal_cart[$delivery_pos]["price"]+$diff_sum, 2, ".", "");
                $this->fiscal_cart[$delivery_pos]["sum"] = number_format(
                                   $this->fiscal_cart[$delivery_pos]["sum"]+$diff_sum, 2, ".", "");
                $this->recalculateTaxes($delivery_pos);
            }
        }
    }

    protected function setOrderTotal($value)
    {
        $this->order_total = $value;
    }

    protected function getOrderTotal($format=FALSE)
    {
        return ($format) ? number_format($this->order_total, 2, ".", "") : 
                                         $this->order_total;
    }

    protected function setShippingPrice($value)
    {
        $this->shipping_price = $value;
    }

    protected function getShippingPrice()
    {
        return $this->shipping_price;
    }

    protected function getPaymentFormType()
    {
        if (strpos($this->order_params["form_url"], "/order/inline") == True)
            return "order";
        else
            return "create";
    }

    protected function setUseTaxes()
    {
        $this->use_taxes = True;
    }

    protected function getUseTaxes()
    {
        return $this->use_taxes;
    }

    protected function setUseDelivery()
    {
        $this->use_delivery = True;
    }

    protected function getUseDelivery()
    {
        return $this->use_delivery;
    }

    protected function recalculateTaxes($item_pos)
    {
        //recalculate taxes
        switch($this->fiscal_cart[$item_pos]['tax']) {
            case "vat10":
                $this->fiscal_cart[$item_pos]['tax_sum'] = round((float)
                    (($this->fiscal_cart[$item_pos]['sum']/110)*10), 2);
                break;
            case "vat18":
                $this->fiscal_cart[$item_pos]['tax_sum'] = round((float)
                    (($this->fiscal_cart[$item_pos]['sum']/118)*18), 2);
                break;
        }
    }

    protected function setTaxes($sum, $tax_rate)
    {
        $taxes = array("tax" => "none", "tax_sum" => 0);
        switch(number_format($tax_rate, 0, ".", "")) {
            case 0:
                $taxes["tax"] = "vat0";
                $taxes["tax_sum"] = number_format(0, 2, ".", "");
                break;
            case 10:
                $taxes["tax"] = "vat10";
                $taxes["tax_sum"] = round((float)(($sum/110)*10), 2);
                break;
            case 18:
                $taxes["tax"] = "vat18";
                $taxes["tax_sum"] = round((float)(($sum/118)*18), 2);
                break;
        }
        return $taxes;
    }

    protected function showDebugInfo($obj_to_debug)
    {
        echo "<pre>";
        var_dump($obj_to_debug);
        echo "</pre>";
    }
}

?>
